#pragma once

#include <event.h>
#include <thread>
#include <deque>

namespace ts {
    namespace webio {
        class LoopManager;
        struct EventLoop {
            friend class LoopManager;
            public:
                event_base* loop;
                std::unique_ptr<std::thread> invoker;

            private:
                void invoker_loop();
        };
        class LoopManager {
            public:
                LoopManager();
                ~LoopManager();

                std::shared_ptr<EventLoop> next_loop();
            private:
                std::atomic<size_t> loop_index{0};
                std::mutex loop_lock;
                std::deque<std::shared_ptr<EventLoop>> loops;
        };
    }
}