#pragma once

#include <query/Command.h>
#include <Error.h>

namespace terminal {
    namespace chandler {
        struct TerminalCommand {
            std::string line;

            std::string command;
            std::string lcommand;

            std::vector<variable> arguments;
            std::vector<std::string> larguments;
        };

        extern void handleCommand(std::string);

        extern bool handleCommandDummyCrash(TerminalCommand&);
        extern bool handleCommandDummyFdFlood(TerminalCommand&);

        extern bool handleCommandHelp(TerminalCommand&);
        extern bool handleCommandEnd(TerminalCommand&);
        extern bool handleCommandInfo(TerminalCommand&);
        extern bool handleCommandChat(TerminalCommand&);

        extern bool handleCommandPermGrant(TerminalCommand&);

        extern bool handleCommandMemFlush(TerminalCommand&);
        extern bool handleCommandMemInfo(TerminalCommand&);
        extern bool handleCommandSpoken(TerminalCommand&);

        extern bool handleCommandPasswd(TerminalCommand&);

        extern bool handleCommandStatsReset(TerminalCommand&);

        extern bool handleCommandReload(TerminalCommand&);
    }
}